<?php

// Copyright 2005 Maxime GEORGE-BOURREAU

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function menu($texte,$presence_rubrique_active=true) {

// Fonction menu

// Renvoie une chaine de caractères contenant du code HTML nécessaire à l'affichage
// d'un menu arborescent dans SPIP.

// Paramètres :

// 1. Mettre dans $texte l'identifiant de rubrique active, si on veut faire apparaitre une rubrique active.
// 2. Mettre $presence_rubrique_active à false si on ne veut pas faire apparaitre de rubrique active.

// Sortie :

// Code HTML nécessaire à l'affiche d'un menu arborescent, sous la forme suivante :

// 1. Chaque rubrique est listée sous la forme :
// <li class="menu-itemX">une rubrique...</li> 
// avec X la profondeur de la rubrique (0=racine du site) 

// 2. Si une rubrique est active, elle est de la forme :
// <li class="menu-itemX menu-selected">une rubrique...</li> 

if ($presence_rubrique_active) $rubrique_active=$texte;
else $rubrique_active=-1;
$rubriques=array();
$requete = mysql_query( "SELECT titre,id_rubrique,id_parent from spip_rubriques order by id_parent,titre");
while ($ligne = mysql_fetch_assoc($requete)) array_push($rubriques,$ligne);
mysql_free_result($requete);
return menu_rec($rubriques,$rubrique_active,0,0);
}

function menu_rec($rubriques,$rubrique_active,$pere,$rang) {

// Fonction menu_rec

// Utilisée par la fonction menu. Explore l'arborescence des rubriques de façon récursive.

	$sortie = '';
	for ($i=0;$i<count($rubriques);$i++) {
		if ($rubriques[$i]['id_parent']==$pere) {
			$sortie .='<li class="menu-item-'.$rang;
			if ($rubrique_active==$rubriques[$i]['id_rubrique']) $sortie .= ' menu-selected';
			$sortie .= '"><a href="rubrique.php3?id_rubrique=';
			$sortie .= $rubriques[$i]['id_rubrique'];
			$titre=ereg_replace("^[0-9]+[.][ ]","",$rubriques[$i]['titre']);
			$sortie .= '">'.$titre.'</a></li>';
			//Ici ajouter condition pour ne pas afficher toutes les noeuds
			$sortie .= menu_rec($rubriques,$rubrique_active,$rubriques[$i]['id_rubrique'],$rang+1);
		}
	}
	return $sortie;
}


?>
